/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-09-16 16:01:30 UTC)
 * on 2013-09-19 at 20:41:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for AllocateIdsResponse.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AllocateIdsResponse extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ResponseHeader header;

  /**
   * The keys specified in the request (in the same order), each with its key path completed with a
   * newly allocated ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Key> keys;

  static {
    // hack to force ProGuard to consider Key used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Key.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public ResponseHeader getHeader() {
    return header;
  }

  /**
   * @param header header or {@code null} for none
   */
  public AllocateIdsResponse setHeader(ResponseHeader header) {
    this.header = header;
    return this;
  }

  /**
   * The keys specified in the request (in the same order), each with its key path completed with a
   * newly allocated ID.
   * @return value or {@code null} for none
   */
  public java.util.List<Key> getKeys() {
    return keys;
  }

  /**
   * The keys specified in the request (in the same order), each with its key path completed with a
   * newly allocated ID.
   * @param keys keys or {@code null} for none
   */
  public AllocateIdsResponse setKeys(java.util.List<Key> keys) {
    this.keys = keys;
    return this;
  }

  @Override
  public AllocateIdsResponse set(String fieldName, Object value) {
    return (AllocateIdsResponse) super.set(fieldName, value);
  }

  @Override
  public AllocateIdsResponse clone() {
    return (AllocateIdsResponse) super.clone();
  }

}
